Robot Simulator of the Robotics Group for Self-Organization of Control: GenContext Class Reference

# GenContext Class Reference

The GenContext class. More...

`#include <GenContext.h>`

Inherits Inspectable.

Collaboration diagram for GenContext:
[legend]

List of all members.

## Public Member Functions
| GenContext (GenPrototype *prototype)
| constructor to create a GenContext.
virtual | ~GenContext ()
| destructor to delete a GenContext.
GenPrototype * | getPrototype (void) const
| [inline], [const]
void | addGen (Gen *gen)
| [inline] This function add a Gen to the Context.
void | removeGen (Gen *gen)
| [inline] This function removes one gen which is saved inside the context (but NO deleting of the gen!!!).
const std::vector< Gen * > & | getGene (void) const
| [inline], [const] This function gives all gens which are saved in this context back.
void | update (double factor=1.5)
| This function makes an update on the statistical values.
## Static Public Member Functions
static bool | restore ()
| restore all GenContext
## Protected Attributes
std::vector< Gen * > | m_storage
| (vector<Gen*> Storage for all Genes which are saved in this context.
GenPrototype * | m_prototype
| (GenPrototyp*) the prototype for which are the context is.
double | m_min
| the min value of the gens
double | m_w1
| the under whisker of the gens
double | m_q1
| the under quartil of the gens
double | m_med
| the median of the gens
double | m_avg
| the average of the gens
double | m_q3
| the upper quartil of the gens
double | m_w3
| the upper whisker of the gens
double | m_max
| the max value of the gens

## Detailed Description

The GenContext class.

This class is used for create a context for some gens. This mean it saves all gens which have the same prototype and are a part of an individual which are in ONE generation. It can be useful for some statistical calculation or for optimizing the mutation factor.

The Gen Context is inside the gen. alg. only saved in the GenPrototype.

## Constructor & Destructor Documentation

GenContext | ( | GenPrototype * | prototype | ) |

constructor to create a GenContext.

Information which the class need are the prototype (name an group of gens).

Parameters:

  | prototype | (GenPrototype*) Pointer to the prototype.

~GenContext | ( |  | ) | `[virtual]`

destructor to delete a GenContext.

## Member Function Documentation

void addGen | ( | Gen * | gen | ) | `[inline]`

[inline] This function add a Gen to the Context.

Parameters:

  | gen | (Gen*) the new Gen, which should be added

const std::vector<Gen*>& getGene | ( | void |  | ) | const`[inline]`

[inline], [const] This function gives all gens which are saved in this context back.

Returns:
  (vector<Gen*>&) list with all gens.

GenPrototype* getPrototype | ( | void |  | ) | const`[inline]`

[inline], [const]

This function gives the prototype for hich are the context is make back.

Returns:
  (GenPrototype*) the prototype

void removeGen | ( | Gen * | gen | ) | `[inline]`

[inline] This function removes one gen which is saved inside the context (but NO deleting of the gen!!!).

param gen (Gen*) The gen, which should be removed

bool restore | ( |  | ) | `[static]`

restore all GenContext

Returns:
  (bool) if all ok

void update | ( | double | factor = `1.5` | ) |

This function makes an update on the statistical values.

Parameters:

  | factor | (double) this factor is normal 1.5 and is for the whisker distance in the analysation

## Member Data Documentation

double m_avg`[protected]`

the average of the gens

double m_max`[protected]`

the max value of the gens

double m_med`[protected]`

the median of the gens

double m_min`[protected]`

the min value of the gens

GenPrototype* m_prototype`[protected]`

(GenPrototyp*) the prototype for which are the context is.

double m_q1`[protected]`

the under quartil of the gens

double m_q3`[protected]`

the upper quartil of the gens

std::vector<Gen*> m_storage`[protected]`

(vector<Gen*> Storage for all Genes which are saved in this context.

double m_w1`[protected]`

the under whisker of the gens

double m_w3`[protected]`

the upper whisker of the gens

The documentation for this class was generated from the following files:

- GenContext.h
- GenContext.cpp